<?php
/*
Plugin Name: Auto Edno23
Plugin URI: http://mpetrov.net
Description: Submit posts or excerpts to edno23 automatically. <a href="/wp-admin/options-general.php?page=auto-edno23/auto_edno23.php">Edno23 Configuration Page</a>
Version: 0.75
Author: Martin Petrov
Author URI: http://mpetrov.net/
*/

function auto_edno23_install () {
	global $wpdb;
  add_option('auto_edno23_options', array('username' => 'username', 'password' => 'password', 'i_replacement' => "\"", 'b_replacement' => '*', 'checkdefault' => 'N'));
  $columns = $wpdb->get_col("DESC $wpdb->posts");
	foreach ($columns as $column)
		if ($column == 'edno23ed')
			return true;
	$wpdb->query("ALTER TABLE $wpdb->posts ADD COLUMN edno23ed enum('Y','N') NOT NULL default 'N'");
}

function auto_edno23_admin_menu() {
  add_options_page('Auto edno23 options', 'Auto edno23', 10, __FILE__, 'auto_edno23_options_page');
}

function auto_edno23_options_page() { ?>
<?php if ($_POST) {
  $ireplace = str_replace("&quot;","\"",$_POST['auto_edno23_ireplace_box']);
  $breplace = str_replace("&quot;","\"",$_POST['auto_edno23_breplace_box']);
  if ($_POST['auto_edno23_password_box'] == "********") {
    $comparison = get_option("auto_edno23_options");
    $password = $comparison['password'];
  } else {
    $password = $_POST['auto_edno23_password_box'];
  }
  if ($_POST['checkdefault']) {
    $checkdefault = 'Y';
  } else {
    $checkdefault = 'N';
  }
  update_option('auto_edno23_options', array("username" => $_POST['auto_edno23_username_box'], "password" => $password, "i_replacement" => $ireplace, "b_replacement" => $breplace, "checkdefault" => $checkdefault)); ?>
<div id="message" class="updated fade"><p>Options updated.</p></div>
<?php }
  $options = get_option("auto_edno23_options");
?>

<div class="wrap">
  <h2>Auto edno23 options</h2>
    <p>Auto Edno23 adds a check box to the Write Post page. If that box is checked when you publish a post, the contents of that post (up to 140 characters) will also be sent to Edno23 as a edno23.</p>
    <form action="" method="post" id="auto_edno23_form">
      <h3>Edno23 user</h3>
      <p>Before you can use Auto Edno23, you must specify a valid Edno23 username and password in the fields below.</p>
      <p><input id="auto_edno23_username_box" name="auto_edno23_username_box" type="text" size="30" value="<?php if ($options['username'] !== 'username') echo $options['username']; ?>" style="font-family: 'Courier New', Courier, Mono; font-size: 1.25em;" /> <label for="auto_edno23_username_box">Username</label><br />
      <input id="auto_edno23_password_box" name="auto_edno23_password_box" type="text" size="30" value="<?php if ($options['password'] !== 'password') echo "********"; ?>" style="font-family: 'Courier New', Courier, Mono; font-size: 1.25em;" /> <label for="auto_edno23_password_box">Password</label></p>
      <h3>Checkbox</h3>
      <p>Should the Auto Edno23 checkbox on the Write Post form be checked by default?</p>
      <p><input id="checkdefault" name="checkdefault" type="checkbox"<?php if ($options['checkdefault'] == "Y") echo ' checked="checked"'; ?> /> <label for="checkdefault">Yes, checked by default.</label></p>
      <p class="submit" style="text-align: left;"><input type="submit" name="submit" value="Update Auto Edno23 &raquo;" /></p>
    </form>
</div>
<?php }

function auto_edno23_form() {
  global $wpdb, $post_ID;
  $edno23ed = $wpdb->get_results("SELECT edno23ed FROM $wpdb->posts WHERE ID = '$post_ID' AND edno23ed = 'Y'");
  $options = get_option('auto_edno23_options'); 
  echo '<fieldset id="auto_edno23_block" class="dbx-box" style="margin-bottom: .5em">' . "\n";
  echo '  <h3 class="dbx-handle">Auto edno23</h3>' . "\n";
  echo '  <div class="dbx-content">' . "\n";
  if ($edno23ed) {
    echo '    <p>This post has already been submitted to Edno23</p>' . "\n";
  } elseif ($options['username'] == 'username' || $options['username'] == '' || $options['password'] == 'password' || $options['password'] == '') {
    echo '    <p>You have not yet entered a Edno23 username or password. You must enter this information in the <a href="';
    bloginfo('wpurl');
    echo '/wp-admin/options-general.php?page=auto_edno23.php">options page</a> before you can use Auto Edno23.</p>' . "\n";
  } else {
    echo '    <p style="line-height: 1.2em; margin-top: .5em; margin-bottom: 0;"><input type="checkbox" name="auto_edno23_checkbox" id="auto_edno23_checkbox"';
    if ($options['checkdefault'] == 'Y') {
      echo ' checked="checked"';
    }
    echo ' onclick="if (this.checked) { document.getElementById(\'counter\').style.display=\'inline\'; } else { document.getElementById(\'counter\').style.display=\'none\'; }" />' . "\n";
    echo '    <label for="auto_edno23_checkbox">Submit to Edno23</label>' . "\n";
    echo '    <span id="counter" style="display: none; color: #ff0000;">&nbsp;</span></p>' . "\n";
    echo '    <script type="text/javascript">' . "\n";
    echo '      // <![CDATA[' . "\n";
    echo '      function countchar(char) {' . "\n";
    echo '        var counter = document.getElementById(\'counter\');' . "\n";
    echo '        var re1 = /<i>|<\/i>|<em>|<\/em>/gi;' . "\n";
    echo '        var re2 = /<b>|<\/b>|<strong>|<\/strong>/gi;' . "\n";
    echo '        var re3 = /(<([^>]+)>)/gi;' . "\n";
    echo '        linkcount = 0;' . "\n";
    echo '        pos = char.indexOf("<a ");' . "\n";
    echo '        while ( pos != -1 ) {' . "\n";
    echo '          linkcount++;' . "\n";
    echo '          pos = char.indexOf("<a ",pos+1);' . "\n";
    echo '        }' . "\n";
    echo '        char = char.replace(re1, "' . $options['i_replacement'] . '");' . "\n";
    echo '        char = char.replace(re2, "' . $options['b_replacement'] . '");' . "\n";
    echo '        char = char.replace(re3, "");' . "\n";
    echo '        var totalchar = char.length;' . "\n";
    echo '        if (linkcount > 0) {' . "\n";
    echo '          var i = 1;' . "\n";
    echo '          while (i <= linkcount) {' . "\n";
    echo '            totalchar = totalchar + 30;' . "\n";
    echo '            i++;' . "\n";
    echo '          }' . "\n";
    echo '        }' . "\n";
    echo '        if (totalchar > 140) {' . "\n";
    echo '          counter.innerHTML=\' (\' + totalchar + \' characters exceeds the maximum length of 140 characters. This entry will be truncated.)\';' . "\n";
    echo '        }' . "\n";
    echo '        if (totalchar <= 140) {' . "\n";
    echo '          counter.innerHTML=\'&nbsp;\';' . "\n";
    echo '        }' . "\n";
    echo '      }' . "\n";
    echo '      var content = document.getElementById("content");' . "\n";
    echo '      content.setAttribute("onkeyup", "countchar(this.value);");' . "\n";
    echo '      // ]]>' . "\n";
    echo '    </script>' . "\n";
  }
  echo '  </div>' . "\n";
  echo '</fieldset>' . "\n";
}

function auto_edno23_submit($post_ID) {
  global $wpdb,$post_ID;
  if ($_POST['auto_edno23_checkbox']) {
    $options = get_option('auto_edno23_options');
    $username = $options['username'];
    $password = $options['password'];
    $content = stripslashes($_POST['post_title']);
    $content="$content ".file_get_contents("http://is.gd/api.php?longurl=".get_permalink($post_ID));

    if (strlen($content) > '140') $content = substr($content, 0, 137) . "...";

$ch1=curl_init(); //Give me a curl unit :P
$postfields="username=$username&password=$password&remember=0";
curl_setopt ($ch1,CURLOPT_URL,"http://edno23.com/login");
curl_setopt ($ch1,CURLOPT_CONNECTTIMEOUT,20);
curl_setopt ($ch1,CURLOPT_RETURNTRANSFER,1);
curl_setopt ($ch1, CURLOPT_POST, 1);
curl_setopt ($ch1, CURLOPT_POSTFIELDS, "$postfields");
curl_setopt ($ch1, CURLOPT_REFERER,"http://www.google.bg/");
curl_setopt ($ch1, CURLOPT_USERAGENT,"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.10) Gecko/20071115 Firefox/2.0.0.10");
curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch1, CURLOPT_COOKIEFILE, $cookie_file_path);
$buffer = curl_exec($ch1);
$postfields="msg=$content&to_user=&attach_link&attach_media";
curl_setopt ($ch1,CURLOPT_URL,"http://edno23.com/post");
curl_setopt ($ch1,CURLOPT_CONNECTTIMEOUT,20);
curl_setopt ($ch1,CURLOPT_RETURNTRANSFER,1);
curl_setopt ($ch1, CURLOPT_POST, 1);
curl_setopt ($ch1, CURLOPT_POSTFIELDS, "$postfields");
curl_setopt ($ch1, CURLOPT_REFERER,"http://$username.edno23.com/");
curl_setopt ($ch1, CURLOPT_USERAGENT,"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.10) Gecko/20071115 Firefox/2.0.0.10");
curl_setopt($ch1, CURLOPT_FOLLOWLOCATION, 1);
$buffer = curl_exec($ch1);
curl_close($ch1);

    $update = $wpdb->query("UPDATE $wpdb->posts SET edno23ed = 'Y' WHERE ID = '$post_ID'");
  }
}

add_action('activate_auto_edno23.php', 'auto_edno23_install');
add_action('admin_menu', 'auto_edno23_admin_menu');
add_action('simple_edit_form', 'auto_edno23_form', 1);
add_action('edit_form_advanced', 'auto_edno23_form', 1);
add_action('publish_post', 'auto_edno23_submit');

?>
